﻿using System;
using System.Collections;
using HeuristicLab.Persistence.Core;
using HeuristicLab.Persistence.Interfaces;

namespace HeuristicLab.Persistence.Default.Decomposers {

  [EmptyStorableClass]
  public class TypeDecomposer : IDecomposer {    
    public bool CanDecompose(Type type) {
      return type == typeof (Type) ||
             type.FullName == "System.RuntimeType";
    }

    public IEnumerable DeCompose(object obj) {
      Type t = (Type) obj;
      yield return t.AssemblyQualifiedName;
    }

    public object Compose(IEnumerable objects, Type type) {
      foreach ( string typeName in objects ) {
        return Type.GetType(typeName);
      }
      return null;
    }
  }
}
